unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Button2: TButton;
    Memo3: TMemo;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
    function EnCryptFile(SourFile:String ; DestFile:String ; FilePassword:String):Boolean;
    function DeCryptFile(SourFile:String ; DestFile:String ; FilePassword:String):Boolean;
    function EnCryptStr(SourStr:String ; var DestStr:String ; StrPassword:String):Boolean;
    function DeCryptStr(SourStr:String ; var DestStr:String ; StrPassword:String):Boolean;
    procedure InitUser;
    function StrToHex(S: string): string;
    function HexToStr(S: string): string;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  //function password(var SourceString: string; MethodIndex: integer): string; external 'MyHash.dll';


implementation

//--------------------------------------
//Crypto API 2.0 ŧiϬq
//--------------------------------------
const
  ALG_CLASS_DATA_ENCRYPT = (3 shl 13);
  ALG_TYPE_BLOCK         = (3 shl  9);
  ALG_TYPE_STREAM        = (4 shl  9);
  ALG_CLASS_HASH         = (4 shl 13);
  ALG_SID_RC2            =  2;
  ALG_SID_RC4            =  1;
  ALG_TYPE_ANY           =  0;
  ALG_SID_MD5            =  3;
  CALG_RC2 = (ALG_CLASS_DATA_ENCRYPT or ALG_TYPE_BLOCK or ALG_SID_RC2);
  CALG_RC4 = (ALG_CLASS_DATA_ENCRYPT or ALG_TYPE_STREAM or ALG_SID_RC4);
  CALG_MD5 = (ALG_CLASS_HASH or ALG_TYPE_ANY or ALG_SID_MD5);
  PROV_RSA_FULL          = 1;
  CRYPT_EXPORTABLE       = $00000001;
  CRYPT_NEWKEYSET        = $00000008;
  AT_KEYEXCHANGE         = 1;
  AT_SIGNATURE           = 2;
  SIMPLEBLOB             = $1;
  PP_CONTAINER           = 6;

  {$IFDEF USE_BLOCK_CIPHER}
  ENCRYPT_ALGORITHM = CALG_RC2;
  ENCRYPT_BLOCK_SIZE = 8;
  {$ELSE}
  ENCRYPT_ALGORITHM = CALG_RC4;
  ENCRYPT_BLOCK_SIZE = 1;
  {$ENDIF}

  MS_DEF_PROV_A = 'Microsoft Base Cryptographic Provider v1.0';
  {$IFNDEF VER90}
  MS_DEF_PROV_W = WideString( 'Microsoft Base Cryptographic Provider v1.0');
  {$ELSE}
  MS_DEF_PROV_W = ( 'Microsoft Base Cryptographic Provider v1.0');
  {$ENDIF}

  {$IFDEF UNICODE}
  MS_DEF_PROV   = MS_DEF_PROV_W;
  {$ELSE}
  MS_DEF_PROV   = MS_DEF_PROV_A;
  {$ENDIF}

type HCRYPTPROV = ULONG;
     HCRYPTKEY  = ULONG;
     HCRYPTHASH = ULONG;
     ALG_ID     = ULONG;

     PHCRYPTPROV = ^HCRYPTPROV;
     PHCRYPTKEY  = ^HCRYPTKEY;
     PHCRYPTHASH = ^HCRYPTHASH;

     {$IFDEF UNICODE}
     LPAWSTR = PWideChar;
     {$ELSE}
     LPAWSTR = PAnsiChar;
     {$ENDIF}


{$IFDEF UNICODE}
function CryptAcquireContext(phProv       :PHCRYPTPROV;
                             pszContainer :LPAWSTR;
                             pszProvider  :LPAWSTR;
                             dwProvType   :DWORD;
                             dwFlags      :DWORD
                             ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptAcquireContextW';
{$ELSE}
function CryptAcquireContext(phProv       :PHCRYPTPROV;
                             pszContainer :LPAWSTR;
                             pszProvider  :LPAWSTR;
                             dwProvType   :DWORD;
                             dwFlags      :DWORD
                             ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptAcquireContextA';
{$ENDIF}


function CryptReleaseContext(hProv   :HCRYPTPROV;
                             dwFlags :DWORD
                             ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptReleaseContext';

function CryptGenKey(hProv   :HCRYPTPROV;
                     Algid   :ALG_ID;
                     dwFlags :DWORD;
                     phKey   :PHCRYPTKEY
                     ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptGenKey';

function CryptGetUserKey(hProv     :HCRYPTPROV;
                         dwKeySpec :DWORD;
                         phUserKey :PHCRYPTKEY
                         ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptGetUserKey';

function CryptExportKey(hKey       :HCRYPTKEY;
                        hExpKey    :HCRYPTKEY;
                        dwBlobType :DWORD;
                        dwFlags    :DWORD;
                        pbData     :PBYTE;
                        pdwDataLen :PDWORD
                        ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptExportKey';

function CryptDestroyKey(hKey  :HCRYPTKEY
                        ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptDestroyKey';

function CryptCreateHash(hProv   :HCRYPTPROV;
                         Algid   :ALG_ID;
                         hKey    :HCRYPTKEY;
                         dwFlags :DWORD;
                         phHash  :PHCRYPTHASH
                         ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptCreateHash';

function CryptHashData(hHash       :HCRYPTHASH;
                const  pbData      :PBYTE;
                       dwDataLen   :DWORD;
                       dwFlags     :DWORD
                       ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptHashData';

function CryptDeriveKey(hProv     :HCRYPTPROV;
                        Algid     :ALG_ID;
                        hBaseData :HCRYPTHASH;
                        dwFlags   :DWORD;
                        phKey     :PHCRYPTKEY
                        ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptDeriveKey';

function CryptDestroyHash(hHash :HCRYPTHASH
                         ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptDestroyHash';

function CryptEncrypt(hKey       :HCRYPTKEY;
                      hHash      :HCRYPTHASH;
                      Final      :BOOL;
                      dwFlags    :DWORD;
                      pbData     :PBYTE;
                      pdwDataLen :PDWORD;
                      dwBufLen   :DWORD
                      ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptEncrypt';

function CryptImportKey(hProv     :HCRYPTPROV;
                        pbData    :PBYTE;
                        dwDataLen :DWORD;
                        hPubKey   :HCRYPTKEY;
                        dwFlags   :DWORD;
                        phKey     :PHCRYPTKEY
                        ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptImportKey';

function CryptDecrypt(hKey       :HCRYPTKEY;
                      hHash      :HCRYPTHASH;
                      Final      :BOOL;
                      dwFlags    :DWORD;
                      pbData     :PBYTE;
                      pdwDataLen :PDWORD
                      ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptDecrypt';

function CryptGetProvParam(hProv      :HCRYPTPROV;
                           dwParam    :DWORD;
                           pbData     :PBYTE;
                           pdwDataLen :PDWORD;
                           dwFlags    :DWORD
                           ) :BOOL; stdcall; external 'advapi32.dll' name 'CryptGetProvParam';


{$R *.DFM}

//---------------------------------------------------------------------------
function TForm1.EnCryptFile(SourFile:String ; DestFile:String ; FilePassword:String):Boolean;
var
  hSource : TFileStream;
  hDestination : TFileStream;
  hProv : HCRYPTPROV;
  hKey  : HCRYPTKEY;
  hXchgKey : HCRYPTKEY;
  hHash : HCRYPTHASH;

  pbKeyBlob : PByte ;
  pbBuffer  : PByte;

  dwKeyBlobLen : DWORD;
  dwBlockLen   : DWORD;
  dwBufferLen  : DWORD;
  dwCount      : DWORD;

  eof : Boolean;
  status : Boolean;
  tmp_buf : array [0..80] of char;

label done;

begin

    hProv   := 0;
    hKey     := 0;
    hXchgKey := 0;
    hHash   := 0;

    eof:=false;
    status:=false;

    hSource := TFileStream.Create(SourFile, fmOpenRead);
    if (hSource=nil) then
       begin
         ShowMessage('Lk}ҭlɮ!');
         goto done;
       end;

    hDestination := TFileStream.Create(DestFile, fmCreate);
    if (hDestination=nil) then
       begin
         ShowMessage('Lk}ҥتɮ!');
         goto done;
       end;


    InitUser;

    if not CryptAcquireContext(@hProv,  nil, nil, PROV_RSA_FULL, 0) then
       begin
         ShowMessage('Lko Handle ');
         goto done;
       end;


    if (FilePassword = '') then //J[K Key  , tΦ۰ʲ Key تY , G[K᪺ɮ Size |Ӥj
       begin

         if not(CryptGenKey(hProv, ENCRYPT_ALGORITHM, CRYPT_EXPORTABLE,@hKey)) then
            begin
              ShowMessage('HȮɵoͿ~I');
              goto done;
            end;

         if not(CryptGetUserKey(hProv, AT_KEYEXCHANGE, @hXchgKey)) then
            begin
              ShowMessage('洫ȮɵoͿ~I');
              goto done;
            end;

         if not(CryptExportKey(hKey, hXchgKey, SIMPLEBLOB, 0, nil, @dwKeyBlobLen)) then
            begin
              ShowMessage(' blof XȮɵoͿ~I');
              goto done;
            end;

         GetMem(pbKeyBlob, dwKeyBlobLen);
         if (pbKeyBlob=nil) then
            begin
              ShowMessage('O餣');
              goto done;
            end;

         if not(CryptExportKey(hKey, hXchgKey, SIMPLEBLOB, 0, pbKeyBlob,@dwKeyBlobLen)) then
            begin
              ShowMessage('Ǧ^ñWɵoͿ~I');
              goto done;
            end;

         CryptDestroyKey(hXchgKey);
         hXchgKey := 0;

         if (hDestination.Write(dwKeyBlobLen, sizeof(DWORD))=0) then
            begin
              ShowMessage('LkgJYI');
              goto done;
            end;

         if (hDestination.Write(pbKeyBlob^,dwKeyBlobLen)=0) then
            begin
              ShowMessage('LkgJYI');
              goto done;
            end;

       end
    else
       begin

         if not(CryptCreateHash(hProv, CALG_MD5, 0, 0, @hHash)) then
            begin
              ShowMessage(' Hash ɵoͿ~I');
              goto done;
            end;

         if not(CryptHashData(hHash, PByte(FilePassword), Length(FilePassword), 0)) then
            begin
              ShowMessage('Lk Hash ȡI');
              goto done;
            end;

         if not(CryptDeriveKey(hProv, ENCRYPT_ALGORITHM, hHash, 0, @hKey)) then
            begin
              ShowMessage('Hash LkǦ^');
              goto done;
            end;

         CryptDestroyHash(hHash);
         hHash := 0;

       end;

    dwBlockLen := (1000 - (1000 mod ENCRYPT_BLOCK_SIZE));

    if (ENCRYPT_BLOCK_SIZE > 1) then
        dwBufferLen := (dwBlockLen + ENCRYPT_BLOCK_SIZE)
    else
        dwBufferLen := dwBlockLen;

    GetMem(pbBuffer, dwBufferLen);
    if (pbBuffer=nil) then
       begin
         ShowMessage('O餣');
         goto done;
       end;


    repeat

        dwCount := hSource.Read(pbBuffer^,dwBlockLen); //O o ^ Ÿ , N error & try F 3,4  - 2003/04/22
        if (dwCount=0) then
           begin
             ShowMessage('Lk}ҭlɡI');
             goto done;
           end;

        eof:=true;

        if not CryptEncrypt(hKey, 0, eof , 0, pbBuffer, @dwCount, dwBufferLen) then
           begin
             ShowMessage('[KwİϸƵoͿ~I');
             goto done;
           end;

        if hDestination.Write(pbBuffer^,dwCount)=0 then
           begin
             ShowMessage('LkgJتɡI');
             goto done;
           end;

    until not(hSource.Position<hSource.Size);

    status := true;
    ShowMessage('ɮץ[K@~I');

 done:

    if(hSource<>nil) then hSource.free;
    if(hDestination<>nil) then hDestination.free;

    if((pbKeyBlob<>nil) and (FilePassword = '')) then FreeMem(pbKeyBlob);
    if(pbBuffer<>nil) then FreeMem(pbBuffer);
    if(hKey<>0) then CryptDestroyKey(hKey);
    if(hXchgKey<>0) then CryptDestroyKey(hXchgKey);
    if(hHash<>0) then CryptDestroyHash(hHash);
    if(hProv<>0) then CryptReleaseContext(hProv, 0);

    Result := status;

end;

//---------------------------------------------------------------------------
function TForm1.DeCryptFile(SourFile:String ; DestFile:String ; FilePassword:String):Boolean;
var
  hSource, hDestination: TFileStream;
  hProv : HCRYPTPROV;
  hKey  : HCRYPTKEY;
  hXchgKey : HCRYPTKEY;
  hHash : HCRYPTHASH;

  pbKeyBlob : PByte;
  pbBuffer  : PByte;

  dwKeyBlobLen : DWORD;
  dwBlockLen   : DWORD;
  dwBufferLen  : DWORD;
  dwCount      : DWORD;

  eof : Boolean;
  status : Boolean;
  tmp_buf : array [0..80] of char;

label done;

begin

    hProv   := 0;
    hKey     := 0;
    hXchgKey := 0;
    hHash   := 0;

    eof:=false;
    status:=false;

    hSource := TFileStream.Create(SourFile, fmOpenRead);
    if (hSource=nil) then
       begin
         ShowMessage('Lk}ҭlɮ!');
         goto done;
       end;

    hDestination := TFileStream.Create(DestFile, fmCreate);
    if (hDestination=nil) then
       begin
         ShowMessage('Lk}ҥتɮ!');
         goto done;
       end;



    InitUser;

    if not(CryptAcquireContext(@hProv,  nil, nil, PROV_RSA_FULL, 0)) then
       begin
         ShowMessage('Lko Handle ');
         goto done;
       end;


    if (FilePassword = '') then
       begin

         if (hSource.Read(dwKeyBlobLen, sizeof(DWORD))=0) then
            begin
              ShowMessage('LkŪYI');
              goto done;
            end;

         GetMem(pbKeyBlob, dwKeyBlobLen);
         if (pbKeyBlob=nil) then
            begin
              ShowMessage('O餣');
              goto done;
            end;

         if (hSource.Read(pbKeyBlob^, dwKeyBlobLen)=0) then
            begin
              ShowMessage('LkŪYI');
              goto done;
            end;

         if not(CryptImportKey(hProv, pbKeyBlob, dwKeyBlobLen, 0, 0, @hKey)) then
            begin
              ShowMessage('q blob oȮɵoͿ~I');
              goto done;
            end;
       end
    else
       begin

         if not(CryptCreateHash(hProv, CALG_MD5, 0, 0, @hHash)) then
            begin
              ShowMessage(' Hash ɵoͿ~I');
              goto done;
            end;

         if not(CryptHashData(hHash, PByte(FilePassword), Length(FilePassword), 0)) then
            begin
              ShowMessage(' Hash ȮɵoͿ~I');
              goto done;
            end;

         if not(CryptDeriveKey(hProv, ENCRYPT_ALGORITHM, hHash, 0, @hKey)) then
            begin
              ShowMessage('o Hash ȮɵoͿ~I');
              goto done;
            end;

         CryptDestroyHash(hHash);
         hHash := 0;

       end;

    dwBlockLen := 1000 - (1000 mod ENCRYPT_BLOCK_SIZE);
    dwBufferLen := dwBlockLen;

    GetMem(pbBuffer, dwBufferLen);
    if (pbBuffer=nil) then
        begin
          ShowMessage('O餣');
          goto done;
        end;


    repeat

         dwCount:=hSource.Read(pbBuffer^,dwBlockLen);
         if (dwCount=0) then
            begin
              ShowMessage('LkŪlɡI');
              goto done;
            end;

         eof := true;

         if not(CryptDecrypt(hKey, 0, eof, 0, pbBuffer, @dwCount)) then
            begin
              ShowMessage('ѱKɵoͿ~I');
              goto done;
            end;

         if (hDestination.Write(pbBuffer^, dwCount)=0) then
            begin
              ShowMessage('LkgJتɡI');
              goto done;
            end;

    until not(hSource.Position<hSource.Size);

    status := true;
    ShowMessage('ɮ׸ѱK@~I');

done:

    if(hSource<>nil) then hSource.free;
    if(hDestination<>nil) then hDestination.free;

    if((pbKeyBlob<>nil) and (FilePassword = '')) then FreeMem(pbKeyBlob);
    if(pbBuffer<>nil) then FreeMem(pbBuffer);
    if(hKey<>0) then CryptDestroyKey(hKey);
    if(hXchgKey<>0) then CryptDestroyKey(hXchgKey);
    if(hHash<>0) then CryptDestroyHash(hHash);
    if(hProv<>0) then CryptReleaseContext(hProv, 0);

    Result := status;

end;
//---------------------------------------------------------------------------
function TForm1.EnCryptStr(SourStr:String ; var DestStr:String ; StrPassword:String):Boolean;
var
  hSource : TStringStream;
  hDestination : TStringStream;
  hProv : HCRYPTPROV;
  hKey  : HCRYPTKEY;
  hXchgKey : HCRYPTKEY;
  hHash : HCRYPTHASH;

  pbKeyBlob : PByte ;
  pbBuffer  : PByte;

  dwKeyBlobLen : DWORD;
  dwBlockLen   : DWORD;
  dwBufferLen  : DWORD;
  dwCount      : DWORD;

  eof : Boolean;
  status : Boolean;
  tmp_buf : array [0..80] of char;

label done;

begin

    hProv   := 0;
    hKey     := 0;
    hXchgKey := 0;
    hHash   := 0;

    eof:=false;
    status:=false;

    hSource := TStringStream.Create(SourStr);
    if (hSource=nil) then
       begin
         ShowMessage('Lk}ҭlɮ!');
         goto done;
       end;

    hDestination := TStringStream.Create('');
    //if (hDestination=nil) then
    //   begin
    //     ShowMessage('Lk}ҥتɮ!');
    //     goto done;
    //   end;

    InitUser;

    if not CryptAcquireContext(@hProv,  nil, nil, PROV_RSA_FULL, 0) then
       begin
         ShowMessage('Lko Handle ');
         goto done;
       end;


    if (StrPassword = '') then //J[K Key  , tΦ۰ʲ Key تY , G[K᪺ɮ Size |Ӥj
       begin

         if not(CryptGenKey(hProv, ENCRYPT_ALGORITHM, CRYPT_EXPORTABLE,@hKey)) then
            begin
              ShowMessage('HȮɵoͿ~I');
              goto done;
            end;

         if not(CryptGetUserKey(hProv, AT_KEYEXCHANGE, @hXchgKey)) then
            begin
              ShowMessage('洫ȮɵoͿ~I');
              goto done;
            end;

         if not(CryptExportKey(hKey, hXchgKey, SIMPLEBLOB, 0, nil, @dwKeyBlobLen)) then
            begin
              ShowMessage(' blof XȮɵoͿ~I');
              goto done;
            end;

         GetMem(pbKeyBlob, dwKeyBlobLen);
         if (pbKeyBlob=nil) then
            begin
              ShowMessage('O餣');
              goto done;
            end;

         if not(CryptExportKey(hKey, hXchgKey, SIMPLEBLOB, 0, pbKeyBlob,@dwKeyBlobLen)) then
            begin
              ShowMessage('Ǧ^ñWɵoͿ~I');
              goto done;
            end;

         CryptDestroyKey(hXchgKey);
         hXchgKey := 0;

         if (hDestination.Write(dwKeyBlobLen, sizeof(DWORD))=0) then
            begin
              ShowMessage('LkgJYI');
              goto done;
            end;

         //ShowMessage(IntToStr(Length(String(pbKeyBlob))));  //nTw 82

         if (hDestination.Write(pbKeyBlob^,dwKeyBlobLen)=0) then
            begin
              ShowMessage('LkgJYI');
              goto done;
            end;

       end
    else
       begin

         if not(CryptCreateHash(hProv, CALG_MD5, 0, 0, @hHash)) then
            begin
              ShowMessage(' Hash ɵoͿ~I');
              goto done;
            end;

         if not(CryptHashData(hHash, PByte(StrPassword), Length(StrPassword), 0)) then
            begin
              ShowMessage('Lk Hash ȡI');
              goto done;
            end;

         if not(CryptDeriveKey(hProv, ENCRYPT_ALGORITHM, hHash, 0, @hKey)) then
            begin
              ShowMessage('Hash LkǦ^');
              goto done;
            end;

         CryptDestroyHash(hHash);
         hHash := 0;

       end;

    dwBlockLen := (1000 - (1000 mod ENCRYPT_BLOCK_SIZE));

    if (ENCRYPT_BLOCK_SIZE > 1) then
        dwBufferLen := (dwBlockLen + ENCRYPT_BLOCK_SIZE)
    else
        dwBufferLen := dwBlockLen;

    GetMem(pbBuffer, dwBufferLen);
    if (pbBuffer=nil) then
       begin
         ShowMessage('O餣');
         goto done;
       end;


    repeat

        dwCount := hSource.Read(pbBuffer^,dwBlockLen); //O o ^ Ÿ , N error & try F 3,4  - 2003/04/22
        if (dwCount=0) then
           begin
             ShowMessage('Lk}ҭlɡI');
             goto done;
           end;

        eof:=true;

        if not CryptEncrypt(hKey, 0, eof , 0, pbBuffer, @dwCount, dwBufferLen) then
           begin
             ShowMessage('[KwİϸƵoͿ~I');
             goto done;
           end;

        if hDestination.Write(pbBuffer^,dwCount)=0 then
           begin
             ShowMessage('LkgJتɡI');
             goto done;
           end;

    until not(hSource.Position<hSource.Size);

    //Ȧry| null D , ҥHݭnN[KGন hex A^
    DestStr:=StrToHex(hDestination.DataString);

    status := true;
    ShowMessage('ɮץ[K@~I');

 done:

    if(hSource<>nil) then hSource.free;
    if(hDestination<>nil) then hDestination.free;

    if((pbKeyBlob<>nil) and (StrPassword = '')) then FreeMem(pbKeyBlob);
    if(pbBuffer<>nil) then FreeMem(pbBuffer);
    if(hKey<>0) then CryptDestroyKey(hKey);
    if(hXchgKey<>0) then CryptDestroyKey(hXchgKey);
    if(hHash<>0) then CryptDestroyHash(hHash);
    if(hProv<>0) then CryptReleaseContext(hProv, 0);

    Result := status;

end;

//---------------------------------------------------------------------------
function TForm1.DeCryptStr(SourStr:String ; var DestStr:String ; StrPassword:String):Boolean;
var
  hSource, hDestination: TStringStream;
  hProv : HCRYPTPROV;
  hKey  : HCRYPTKEY;
  hXchgKey : HCRYPTKEY;
  hHash : HCRYPTHASH;

  pbKeyBlob : PByte;
  pbBuffer  : PByte;

  dwKeyBlobLen : DWORD;
  dwBlockLen   : DWORD;
  dwBufferLen  : DWORD;
  dwCount      : DWORD;

  eof : Boolean;
  status : Boolean;
  tmp_buf : array [0..80] of char;

  ss : String;


label done;

begin

    hProv   := 0;
    hKey     := 0;
    hXchgKey := 0;
    hHash   := 0;

    eof:=false;
    status:=false;

    //N HEX ѽX
    ss:=HexToStr(SourStr);

    hSource := TStringStream.Create(ss);
    if (hSource=nil) then
       begin
         ShowMessage('Lk}ҭlɮ!');
         goto done;
       end;

    hDestination := TStringStream.Create('');
    //if (hDestination=nil) then
    //   begin
    //     ShowMessage('Lk}ҥتɮ!');
    //     goto done;
    //   end;

    InitUser;

    if not(CryptAcquireContext(@hProv,  nil, nil, PROV_RSA_FULL, 0)) then
       begin
         ShowMessage('Lko Handle ');
         goto done;
       end;
    

    if (StrPassword = '') then
       begin

         if (hSource.Read(dwKeyBlobLen, sizeof(DWORD))=0) then
            begin
              ShowMessage('LkŪYI');
              goto done;
            end;

         GetMem(pbKeyBlob, dwKeyBlobLen);
         if (pbKeyBlob=nil) then
            begin
              ShowMessage('O餣');
              goto done;
            end;

         if (hSource.Read(pbKeyBlob^, dwKeyBlobLen)=0) then
            begin
              ShowMessage('LkŪYI');
              goto done;
            end;

         if not(CryptImportKey(hProv, pbKeyBlob, dwKeyBlobLen, 0, 0, @hKey)) then
            begin
              ShowMessage('q blob oȮɵoͿ~I');
              goto done;
            end;
       end
    else
       begin

         if not(CryptCreateHash(hProv, CALG_MD5, 0, 0, @hHash)) then
            begin
              ShowMessage(' Hash ɵoͿ~I');
              goto done;
            end;

         if not(CryptHashData(hHash, PByte(StrPassword), Length(StrPassword), 0)) then
            begin
              ShowMessage(' Hash ȮɵoͿ~I');
              goto done;
            end;

         if not(CryptDeriveKey(hProv, ENCRYPT_ALGORITHM, hHash, 0, @hKey)) then
            begin
              ShowMessage('o Hash ȮɵoͿ~I');
              goto done;
            end;

         CryptDestroyHash(hHash);
         hHash := 0;

       end;

    dwBlockLen := 1000 - (1000 mod ENCRYPT_BLOCK_SIZE);
    dwBufferLen := dwBlockLen;

    GetMem(pbBuffer, dwBufferLen);
    if (pbBuffer=nil) then
        begin
          ShowMessage('O餣');
          goto done;
        end;


    repeat

         dwCount:=hSource.Read(pbBuffer^,dwBlockLen);
         if (dwCount=0) then
            begin
              ShowMessage('LkŪlɡI');
              goto done;
            end;

         eof := true;

         if not(CryptDecrypt(hKey, 0, eof, 0, pbBuffer, @dwCount)) then
            begin
              ShowMessage('ѱKɵoͿ~I');
              goto done;
            end;

         if (hDestination.Write(pbBuffer^, dwCount)=0) then
            begin
              ShowMessage('LkgJتɡI');
              goto done;
            end;

    until not(hSource.Position<hSource.Size);

    DestStr:=hDestination.DataString;

    status := true;
    ShowMessage('ɮ׸ѱK@~I');

done:

    if(hSource<>nil) then hSource.free;
    if(hDestination<>nil) then hDestination.free;

    if((pbKeyBlob<>nil) and (StrPassword = '')) then FreeMem(pbKeyBlob);
    if(pbBuffer<>nil) then FreeMem(pbBuffer);
    if(hKey<>0) then CryptDestroyKey(hKey);
    if(hXchgKey<>0) then CryptDestroyKey(hXchgKey);
    if(hHash<>0) then CryptDestroyHash(hHash);
    if(hProv<>0) then CryptReleaseContext(hProv, 0);

    Result := status;

end;
//---------------------------------------------------------------------------
procedure TForm1.InitUser;
var
  hProv : HCRYPTPROV;
  hKey  : HCRYPTKEY;
  dwUserNameLen : DWORD;
  szUserName : array [0..100] of char;
  tmp_buf : array [0..80] of char;
  
begin

    hProv:=0;
    hKey:=0;
    dwUserNameLen := 100;

    // Attempt to acquire a handle to the default key container.
    if not(CryptAcquireContext(@hProv, nil, MS_DEF_PROV, PROV_RSA_FULL, 0))  then
       begin
         // Some sort of error occured.

         // Create default key container.
         if not(CryptAcquireContext(@hProv, nil, MS_DEF_PROV, PROV_RSA_FULL, CRYPT_NEWKEYSET)) then
            begin
              ShowMessage('Error creating key container!');
              Exit;
            end;

         // Get name of default key container.
         if not(CryptGetProvParam(hProv, PP_CONTAINER, (@szUserName), @dwUserNameLen, 0)) then
            begin
              // Error getting key container name.
              szUserName[0] := Char(0);
            end;

         ShowMessage('Create key container '+String(szUserName));

       end;

    // Attempt to get handle to signature key.
    if not CryptGetUserKey(hProv, AT_SIGNATURE, @hKey) then
       begin
         if (GetLastError()=DWORD(NTE_NO_KEY)) then  //[ DWORD() û]񤣥X...Delphi 5  bug ??
            begin
              // Create signature key pair.
              ShowMessage('Create signature key pair');

              if not(CryptGenKey(hProv,AT_SIGNATURE,0,@hKey)) then
                 begin
                   ShowMessage('Error during CryptGenKey (1)!');
                   Exit;
                 end
              else
                 begin
                   CryptDestroyKey(hKey);
                 end;

            end
         else
            begin
              ShowMessage('Error during CryptGetUserKey (1)!');
              Exit;
            end;
       end;

    // Attempt to get handle to exchange key.
    if not(CryptGetUserKey(hProv,AT_KEYEXCHANGE,@hKey)) then
       begin

         if(GetLastError()=DWORD(NTE_NO_KEY)) then  //[ DWORD() û]񤣥X...Delphi 5  bug ??
           begin
             // Create key exchange key pair.
             ShowMessage('Create key exchange key pair');

             if not(CryptGenKey(hProv,AT_KEYEXCHANGE,0,@hKey)) then
                begin
                  ShowMessage('Error during CryptGenKey (2)!');
                  Exit;
                end
             else
                begin
                  CryptDestroyKey(hKey);
                end;

           end
         else
           begin
             ShowMessage('Error during CryptGetUserKey (2)!');
             Exit;
           end;

       end;

    CryptReleaseContext(hProv,0);

end;
//---------------------------------------------------------------------------
function TForm1.StrToHex(S: string): string;
var
  i: integer;
begin
  Result := '';
  for i := 1 to Length( S ) do
      Result := Result + IntToHex( Ord( S[i] ), 2 );
end;
//---------------------------------------------------------------------------
function TForm1.HexToStr(S: string): string;
var
  i: integer;
begin
  Result := '';
  for i := 1 to Length( S ) do
  begin
    if ((i mod 2) = 1) then
      	Result := Result + Chr( StrToInt( '0x' + Copy( S, i, 2 )));
  end;
end;
//---------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo1.Lines.SaveToFile('c:\1.txt');
  EnCryptFile('c:\1.txt','c:\2.txt','');
  Memo2.Lines.LoadFromFile('c:\2.txt');
end;
//---------------------------------------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
begin
  DeCryptFile('c:\2.txt','c:\3.txt','');
  Memo3.Lines.LoadFromFile('c:\3.txt');
end;
//---------------------------------------------------------------------------
procedure TForm1.Button3Click(Sender: TObject);
var tmp_buf : String;
begin
  EnCryptStr(Memo1.Text,tmp_buf,'');
  Memo2.Text:=tmp_buf;
end;
//---------------------------------------------------------------------------
procedure TForm1.Button4Click(Sender: TObject);
var tmp_buf : String;
begin
  DeCryptStr(Memo2.Text,tmp_buf,'');
  Memo3.Text:=tmp_buf;
end;
//---------------------------------------------------------------------------
procedure TForm1.Button5Click(Sender: TObject);
var Source,EnCrypt,DeCrypt : String;
begin
  if (OpenDialog1.Execute()) then
      begin
        Source:=OpenDialog1.FileName;
        EnCrypt:=Source+'.EnCrypt';
        DeCrypt:=Source+'.DeCrypt';

        EnCryptFile(Source,EnCrypt,'');
        DeCryptFile(EnCrypt,DeCrypt,'');
        ShowMessage(DeCrypt+' ɮ٭첣');
      end;
end;
//---------------------------------------------------------------------------
procedure TForm1.Button6Click(Sender: TObject);
begin
  InitUser;
end;

end.

{

XƸ`

  hProv: HCRYPTPROV;
  hash: HCRYPTHASH;
  password: string;
  key: HCRYPTKEY;
  plaintext, ciphertext: string;
  inFile, outFile: file;
  data: PByte;
  l: DWORD;

  CryptAcquireContext(@hProv, nil, nil, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT);

  CryptCreateHash(hProv, CALG_SHA, 0, 0, @hash);

  CryptHashData(hash, @password[1], length(password), 0);

  CryptDeriveKey(hProv, CALG_RC4, hash, 0, @key);

  CryptDestroyHash(hash);

  AssignFile(inFile, plaintext);
  AssignFile(outFile, ciphertext);
  reset(inFile, 1);
  rewrite(outFile, 1);

  GetMem(data, 512);

  while not eof(inFile) do
  begin
    BlockRead(inFile, data^, 512, l);
    CryptEncrypt(key, 0, eof(inFile), 0, data, @l, l);
    BlockWrite(outFile, data^, l);
  end;

  FreeMem(data, 512);
  CloseFile(inFile);
  CloseFile(outFile);

  CryptReleaseContext(hProv, 0);

}
